<?php
//
//リファラーを自動的に取得してページ内リンクを自動生成するPHPプログラム<br>
//@author MRB(Project Feel-Good,http://ek-pro.com/
//@version 1.0
//
	
	//HTTPホスト+http://を取得
	//もし、あなたのサイトがhttp://www.example.com/yourname/ 以下であるならば、
	//以下の値を変更してください
//	$httphost = "http://" . $_SERVER['HTTP_HOST'];
	$httphost = "http://website.ek-pro.com/lab/20080512";
   
	//HTTPリファラーを取得
	$httpreferer = $_SERVER['HTTP_REFERER'];

	//URIを取得
	$URI = $_SERVER['REQUEST_URI'];

	//"index.html"などを削除
	$httpreferer = removeDirIdx($httpreferer);
	$URI = removeDirIdx($URI);

	//URIをURLエンコード
	//http://phpspot.net/php/pgURL%83G%83%93%83R%81%5B%83h,%83f%83R%81%5B%83h.html
	$encURI = urlencode($URI);

	//データを保存するディレクトリ＋ファイル名
	$filename = "./data/" . $encURI;

	//HTTPリファラーからサイト内アクセスであることを確認する
	//URLの初めから一致する（値が0）＝自サイト内アクセス
	//URLの途中で一致する＝検索エンジンなどからのアクセス
	//一致しない＝別サイトからのアクセス
	//http://phpspot.net/php/man/php/function.strpos.html
	$isMyself = strpos($httpreferer,$httphost);
	if ($isMyself===0) {

		//ファイルが存在している場合は、既にリファラーが存在しているかチェックする
		//http://www.ibm.com/developerworks/jp/opensource/library/os-php-readfiles/
		if (file_exists($filename) && is_readable ($filename)) {
			//$filename の中身を取得し、１行ごとに配列へ格納
			$arrRefFileLines = file($filename);

			//既にそのリファラーがファイルに存在しているか
			//http://phpspot.net/php/man/php/function.strpos.html
			for($i=0; $i<count($arrRefFileLines); $i++){

				//$filename はカンマ区切りなので、","で分割
				$pieces = explode(",", $arrRefFileLines[$i]);

				//httpreferer内の","を" "に変えて書き出しているので、ここでも一時的に書き直す
				//" "はURLに存在していない（そもそも使えない。RFC1738）ことが前提
				if (str_replace(","," ",$httpreferer) == $pieces[0]){
					$isRefExist = true;
					break;
				}
			}
		}

		//ファイルが存在していない、もしくは
		//該当ファイルにリファラーが存在していないなら、
		//（ファイルを作成し）リファラーを追加
		if ( !(file_exists($filename)) || !($isRefExist === true)){
		   
			//タイトルを取得する
			//http://ml.php.gr.jp/pipermail/php-users/2006-August/030629.html
			$data = file_get_contents($httpreferer);
			preg_match_all('@<title(.*?)>(.*?)<\/title>@is', $data, $title);
			$strTitle =  $title[2][0];
		   
			//タイトルの整形
			//\を削除
			$strTitle = stripslashes($strTitle);
			//改行を削除
			$strTitle = ereg_replace("\r|\n","",$strTitle);
			//<」、「>」、「&」、「"」を記号文字に変換
			$strTitle = htmlspecialchars($strTitle);
			//半角スペースを&nbsp;に変換
			$strTitle = ereg_replace(" ","&nbsp;",$strTitle);
			//カンマをスペースに変更
			$strTitle = ereg_replace(","," ",$strTitle);
		   
			//URLの整形(,を" "に変換しておく)…split処理のため
			$httpreferer = ereg_replace(","," ",$httpreferer);

			//ファイルを開きます
			//http://w1.nirai.ne.jp/freeze/kiso/file.html
			$pointer=fopen($filename, "a");

			//ファイルをロック
			flock($pointer, LOCK_EX);

			//書込み
			fputs($pointer, $httpreferer.",".$strTitle."\n");

			//ロック解除
			flock($pointer, LOCK_UN);

			//ファイルを閉
			fclose($pointer);
		}
	}

	//リンク元一覧を書き出す
	if (file_exists($filename) && is_readable ($filename)) {
		$arrRefFileLines = file($filename);
   
		print "<ul class=\"autoref\">\n";
		for($i=0; $i<count($arrRefFileLines); $i++){
		//$filename はカンマ区切りなので、","で分割
			$pieces = explode(",", $arrRefFileLines[$i]);
			$pieces[1] = ereg_replace("\r|\n","",$pieces[1]);
			if ($pieces[1] == ""){
				$pieces[1] = "no title";
			}
			$pieces[0] = str_replace(" ",",",$pieces[0]);
			print "<li><a href=\"".$pieces[0]."\">".$pieces[1]."</a></li>\n";
		}
		print "</ul>\n";
	}

function removeDirIdx($URLString) {
	//最後の文字が"/"かどうか
	if (!(substr($URLString,-1) == "/")){
		//"/"でなければ、URLの最後から/まで（例：index.html、first.htmlなど）を取得する
		$URLStringLastStr = ereg_replace("/","",strrchr($URLString, "/"));
		//リファラーの最後が
		//index.php index.php4 index.php3 index.cgi index.pl index.html index.htm index.shtml index.phtml index.jspか
		if ($URLStringLastStr == "index.php" ||
				$URLStringLastStr == "index.php4" ||
				$URLStringLastStr == "index.php3" ||
				$URLStringLastStr == "index.cgi" ||
				$URLStringLastStr == "index.pl" ||
				$URLStringLastStr == "index.html" ||
				$URLStringLastStr == "index.htm" ||
				$URLStringLastStr == "index.shtml" ||
				$URLStringLastStr == "index.phtml" ||
				$URLStringLastStr == "index.jsp") {
			//それらを削除
			$URLString = ereg_replace("index.php$|index.php4$|index.php3$|index.cgi$|index.pl$|index.html$|index.htm$|index.shtml$|index.phtml$|index.jsp$","",$URLString);
		}
	}
	return $URLString;
}
?>
 